#!/bin/bash

# This script starts the programs necessary to test a
# "networked jack setup". See the README file for an overview.

# We are using a locally installed version of JACK
export LD_LIBRARY_PATH=/tmp/jack/lib

echo "starting jack server"
/tmp/jack/bin/jackd -d alsa -d delta -r 44100 -n 11 -p 512 -P &
jackdpid=$!

# This is actually started on the remote machine
#echo "starting echoserver"
#./echoserver -c 2 -r 127.0.0.1 3000 3001 3002 3003 &
#serverpid=$!

sleep 2
echo "starting jack client"
./masterclient -i 1 -o 1 -r 192.168.3.2 3000 3001 &
clientpid=$!

sleep 3
echo "starting alsaplayer"
alsaplayer -i gtk -o jack $* &
playerpid=$!

sleep 8
echo "starting slider"
./fltk_client &
sliderpid=$!

sleep 8
echo "Force graph order:"
echo "transmitter first"
/tmp/jack/bin/jack_connect masterclient-${clientpid}.trans:dumyout fltktest:input
sleep 8
echo "receiver last"
/tmp/jack/bin/jack_connect fltktest:output masterclient-${clientpid}.rec:dumyin

sleep 8
echo "Connect currently silent outputs to soundcard:"
echo "slider to left channel"
/tmp/jack/bin/jack_connect fltktest:output alsa_pcm:out_1
sleep 8
echo "remote processor to right channel"
/tmp/jack/bin/jack_connect masterclient-${clientpid}.rec:out_1 alsa_pcm:out_2

sleep 8
echo "Detach player from soundcard left channel:"
/tmp/jack/bin/jack_disconnect alsaplayer-${playerpid}:out_1 alsa_pcm:out_1
sleep 8
echo "Connect player to slider: local-processed channel (left) starts playback"
/tmp/jack/bin/jack_connect alsaplayer-${playerpid}:out_1 fltktest:input

sleep 8
echo "Detach player from soundcard right channel"
/tmp/jack/bin/jack_disconnect alsaplayer-${playerpid}:out_2 alsa_pcm:out_2
sleep 8
echo "Connect player to transmitter: remote-processed channel (right) starts playback"
/tmp/jack/bin/jack_connect alsaplayer-${playerpid}:out_2 masterclient-${clientpid}.trans:in_1

sleep 8
echo "all done!"

echo "alsaplayer: $playerpid; masterclient: $clientpid; fltk_client: $sliderpid; echoserver: $serverpid jack server: $jackpid."
