///////////////////////////////////////////////////////////////////////////////
//             includes, defines, declarations etc.
///////////////////////////////////////////////////////////////////////////////
#include <string> // used by myipaddr.hh
#include <sstream> // used in this file
#include <iostream> // used in this file

// These are needed by mysocket.hh:
#include <sys/time.h>
#include <time.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>


#include "myipaddr.hh"
#include "mysocket.hh"
#include <jack/jack.h>
#include "chain.hh"
#include "master_callbacks.hh"


int
transmit (jack_nframes_t nframes, void *object)
{
	return static_cast<chain*>(object)->transmit (nframes);
}

int
receive (jack_nframes_t nframes, void *object)
{
	return static_cast<chain*>(object)->receive (nframes);
}

int
changeBufsize (jack_nframes_t nframes, void *object)
{
	return static_cast<chain*>(object)->changeBufsize (nframes);
}

int
changeRate (jack_nframes_t nframes, void *object)
{
	return static_cast<chain*>(object)->changeRate (nframes);
}

void
destroyReceiver (void *object)
{
	static_cast<chain*>(object)->destroyReceiver ();
}

void
destroyTransmitter (void *object)
{
	static_cast<chain*>(object)->destroyTransmitter ();
}
