#ifndef SLAVE_HH
#define SLAVE_HH

// For the slave chain, we need to tell jack when we've timed out;
// this timeout should be very big, since we actually sleep waiting
// for network data. This is this time, in microsecs (default 8secs)

enum { MAX_CICLE_TIME = 8000000 };


///////////////////////////////////////////////////////////////////////////////
// These are the callbacks that will be registered with JACK when we are
// running as the driver; they call the appropriate methods on the
// slaveChain object.
///////////////////////////////////////////////////////////////////////////////

typedef struct {
	JACK_DRIVER_DECL

	slaveChain *chain;

} network_driver_t;

jack_driver_t* driver_initialize (int argc, char** argv);

#endif
